; Author : Quentin BENETHUILLERE
; Date of creation : 2021/03/22
; Last modification : 2021/03/22

  .include "tn45def.inc"

	.def	mask 	= r16		; mask register
	.def	ledR 	= r17		; led register
	.def	oLoopR 	= r18		; outer loop register
	.def	iLoopRl = r24		; inner loop register low
	.def	iLoopRh = r25		; inner loop register high

  .equ	oVal 	= 71 ; outer loop value.
	.equ	iVal 	= 28168		; inner loop value
	; The values chosen for the previous constants will give about 1 second delay between each LED state change.

	.cseg
	.org	0x00
	
	;LED is connected to PINB3.
	
	clr	ledR			; clear led register
	ldi	mask,(1<<3)		; load 00001000 into mask register
	out	DDRB,mask		; set PINB3 to output

start:	eor	ledR,mask		; toggle PINB3 in led register
	out	PORTB,ledR		; write led register to PORTB

	ldi	oLoopR,oVal		; initialize outer loop count

oLoop:	ldi	iLoopRl,LOW(iVal)	; intialize inner loop count in inner
	ldi	iLoopRh,HIGH(iVal)	; loop high and low registers

iLoop:	sbiw	iLoopRl,1		; decrement inner loop registers
	brne	iLoop			; branch to iLoop if iLoop registers != 0

	dec	oLoopR			; decrement outer loop register
	brne	oLoop			; branch to oLoop if outer loop register != 0

	rjmp	start			; jump back to start