; Author : Quentin BENETHUILLERE
; Date of creation : 2021/03/22
; Last modification : 2021/03/22

	.include "tn45def.inc"

	.def	led_mask 	= r16		; led mask register
	.def	ledR 	= r17		; led register
	.def	button_mask = r18	; button register
	.def	buttonR = r19	; button register
	.def	portB_temp = r20

	.cseg
	.org	0x00
	
  ;LED/MOSFET base is connected to PINB3.
	;Button is connected to PINB4. 0 when button is pushed, 1 when button is released.
	
	clr	ledR			; clear led register
	ldi	led_mask,(1<<3)		; load 00001000 into mask register
	ldi	button_mask,(1<<4)		; load 00010000 into button mask register
	out	DDRB,led_mask		; set PINB3 to output and all the other pins to input
	
start:	in buttonR,PINB
	and buttonR,button_mask
	brne button_pushed
	eor portB_temp,led_mask
	out PORTB,portB_temp
	rjmp start	; jump back to start
	
button_pushed:
	or portB_temp,led_mask
	out PORTB,portB_temp
	rjmp start	; jump back to start